//
//  NEXTimeOfDay.h
//  NumberEightCompiled
//
//  Created by Oliver Kocsis on 19/06/2018.
//  Copyright © 2018 NumberEight Technologies Ltd. All rights reserved.
//
#pragma once

#import "NETime.h"
#import "NEXSensorItem.h"

NS_ASSUME_NONNULL_BEGIN
/**
 * A representation of semantic time relative to the user's habits, and a type of day.
 *
 * Time of day represents semantic time (e.g. lunch, dinner, evening).
 * Type of day represents whether it is a weekday, weekend, or holiday.
 */
@interface NEXTime : NEXSensorItem

/**
 * Default constructor.
 */
- (instancetype)init;

/**
 * Default constructor.
 */
+ (instancetype)new;

/**
 * Conversion copy constructor.
 * @param time NETime to copy from.
 */
- (instancetype)initWithTime:(NETime)time;

/**
 * Conversion copy constructor.
 * @param time NETime to copy from.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithTime:(NETime)time confidence:(double)confidence;

/**
 * @param time Time of day to assume.
 */
- (instancetype)initWithTimeTime:(NETimeTime)time;

/**
 * @param time Time of day to assume.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithTimeTime:(NETimeTime)time confidence:(double)confidence;

/**
 * @param type Type of day to assume.
 */
- (instancetype)initWithType:(NETimeType)type;

/**
 * @param type Type of day to assume.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithType:(NETimeType)type confidence:(double)confidence;

/**
 * @param time Time of day to assume.
 * @param type Type of day to assume.
 */
- (instancetype)initWithTime:(NETimeTime)time type:(NETimeType)type;

/**
 * @param time Time of day to assume.
 * @param type Type of day to assume.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithTime:(NETimeTime)time type:(NETimeType)type confidence:(double)confidence;

/**
 * Parse a string in serialized form.
 * @param string The serialized string, as generated by serialize()
 *
 * @return `nil` if unserialization failed.
 */
+ (instancetype _Nullable)unserializeWithString:(NSString*)string;

@property(nonatomic, readonly) NETime value DEPRECATED_ATTRIBUTE;

/**
 * Semantic time relative to the user's habits.
 */
@property(nonatomic, readwrite) NETimeTime time;

/**
 * Semantic type of day.
 */
@property(nonatomic, readwrite) NETimeType dayType;

+ (NSString*)stringFromTime:(NETimeTime)time;
+ (NSString*)stringFromType:(NETimeType)type;

/**
 * @return A hash value representing the state of the Type.
 *          Can be used for checking equality.
 */
@property(nonatomic, readonly) NSUInteger hash;

/**
 * @return The name of the concrete value class extending NEXSensorItem.
 */
@property(nonatomic, readonly) NSString* type;

/**
 * @return A human-readable format of the held data.
 */
@property(nonatomic, readonly) NSString* description;

/**
 * @return A machine-readable format of the held data.  Returns `nil` if @p type is invalid, or if
 * serialization failed.
 */
- (NSString* _Nullable)serialize;

/**
 * Strict equality comparison.
 *
 * @see NETime_isEqual
 *
 * @param object Value to compare with.
 */
- (BOOL)isEqual:(id _Nullable)object;

/**
 * Convert the Objective-C class to a C-compatible struct.
 */
- (NETime)c_val;

@end
NS_ASSUME_NONNULL_END
